#include <stdio.h>
#include <stdlib.h>
#include <math.h>

const MAX = 1100000;
int N;
int x[MAX], y[MAX];
const double EPS = 1e-5;

int uloh,ul;

void plocha(int i, int j, int k, double &S, double &xx, double &yy)
{
  double ux,uy,vx,vy;
  ux = x[k] - (double)x[i];
  uy = y[k] - (double)y[i];
  vx = x[j] - (double)x[i];
  vy = y[j] - (double)y[i];
  S = (ux*(double)vy - uy*(double)vx)/2.0;
  xx = (x[i]+(double)x[j]+x[k])/3.0;
  yy = (y[i]+(double)y[j]+y[k])/3.0;
}

void compute()
{
  int i;
  double SS, xxx,yyy,S,xx,yy;
  SS = 0; xxx = yyy = 0;
  for(i=1; i<N-1; i++) {
    plocha(0,i,i+1, S,xx,yy);
    
    //printf("pl[%d] =%lf, xx= %f, yy = %f\n",i,S,xx,yy);
    SS += S; 
    xxx+=xx*S; yyy+=yy*S;
  }
  //printf ("plocha = %.2f\n",SS);
  xxx /= SS; 
  yyy /= SS;
  if (fabs(xxx)<EPS) xxx = 0;
  if (fabs(yyy)<EPS) yyy = 0;
  //xxx += EPS; yy += EPS;
  printf("%0.2f %0.2f\n",xxx,yyy);
}

int main()
{
  int i;
  scanf("%d ",&uloh);
  for(ul=1; ul<=uloh; ul++) {
    scanf("%d ", &N);
    for(i=0; i<N; i++) {
      scanf("%d %d ", &x[i], &y[i]);
    }
    compute();
  }
  //printf("%0.2f\n",0.005);
  return 0;
}